//
// Copyright 2007, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.
//
// Warning:  not all files in this directory structure are covered by the
// same copyright.  Some of them are part of the GNU source distribution
// and you must obey the GPL copyright for those files.

#ifdef _MSC_VER
#  include <io.h>
#  define S_IREAD  _S_IREAD
#  define S_IWRITE _S_IWRITE
#else
#  include <unistd.h>
#endif

#include <fcntl.h>
#include <sys/stat.h>
#include <iostream>

#include "myOstream.h"


struct myOfileStream::impl
{
   int fh_;

};

myOfileStream::myOfileStream(char const *filename)
{
  implementation_ = new impl;

  implementation_->fh_ = open(filename, O_WRONLY|O_CREAT|O_TRUNC, S_IREAD|S_IWRITE);

}

myOfileStream::~myOfileStream()
{
  flush();
  close(implementation_->fh_);
  delete implementation_;
}

bool
myOfileStream::
WriteFile(char const *buffer, size_t len, size_t *bytesWritten)
{
  *bytesWritten = write(implementation_->fh_, buffer, len);

  return len == *bytesWritten;

}

