//
// Copyright 2007, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.
//
// Warning:  not all files in this directory structure are covered by the
// same copyright.  Some of them are part of the GNU source distribution
// and you must obey the GPL copyright for those files.

#define MYOSTREAM_PLAYS_NICE_WITH_STD_OSTREAM 1

#include <iostream>
#include "myOstream.h"

myOstream &myOstream::operator<< ( std::ostream & (*ptr)(std::ostream& ) )
{
  //
  //  Let std::endl work correctly
  //

  static std::ostream &(*endlPtr)(std::ostream &) = std::endl;
  static std::ostream &(*flushPtr)(std::ostream &) = std::flush;


  if( ptr ==  endlPtr)
  {
    return myOendl(*this);
  }
  else
  if( ptr == flushPtr )
  {
    return myOflush(*this);
  }

  return *this;
}

myOstream &myOstream::operator<< ( std::ios_base& (*ptr)(std::ios_base &b) )
{
  //
  //  let std::hex work correctly
  //

  if(ptr == &std::hex )
  {
    outputBase = hexOutput;
  }
  else
  if(ptr == &std::dec )
  {
    outputBase = decimalOutput;
  }
  else
  if(ptr == &std::oct )
  {
    outputBase = octalOutput;
  }
  else
  if(ptr == &std::showbase )
  {
    showBase_ = true;
  }
  else
  if(ptr == &std::noshowbase )
  {
    showBase_ = false;
  }


  return *this;
}

