//
// Copyright 2007, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.
//
// Warning:  not all files in this directory structure are covered by the
// same copyright.  Some of them are part of the GNU source distribution
// and you must obey the GPL copyright for those files.

#define MYOSTREAM_PLAYS_NICE_WITH_STD_OSTREAM 1

#include <iostream>
#include "myOstream.h"

using namespace std;

struct stuff
{
  int x;
  int y;
  float z;

  stuff()
  : x(100),
    y(200),
    z(1.0)
  {
  }
};

template<> myOstream &myOstream::operator<<(stuff const &s)
{
  return (*this) << "h"  << hex << s.x 
                 << " o" << oct << s.y 
                 << ' ' << 'd' << dec << 40 
                 << ' ' << 'f' << s.z
                 << ' ' << showbase << myOhex << (unsigned long)(-1)
                 << ' ' << myOdec << (unsigned long)(-1)
                 << myOnoshowbase
                 ;
}


static void bye()
{
}

int main()
{

  {
    myCoutStream& os = myOcout;
  
    stuff     stuff1;
  
    cout << "\n\n--------------------------------\n\n";
    cout << "Test of myOstream with ostream compatibilitiy begins\n" << endl;
  
    cout << "\n\n--------------------------------\n\n" << endl;

    os << "hi there, 7 == " << 7 << ", and 4.1 == " << 4.1 << myOendl;
  
    os << "stuff == " << stuff1 << myOendl;
  
    os << endl;
  
    os << "trailing crap" << endl;
  
    os << "Width/fill testing begins: " << myOendl;
    os << "20xes should look like this:  " << myOsetfill('x') <<  myOsetw(20) << ""  << myOendl;
    os << "and this should not have xes after it:  " << 4 << myOendl;
  
    cout << "The number of characters written to the stream is " << os.tellp() << endl;
  
    bye();
  }

  cout << "os should be gone by now" << endl;

  {
    myOfileStream junk("junk.out");

    junk << "Hi there guy!" << myOendl;

  }

}
